#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct ProcedureSearchState {
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::ProcedureSortOptions>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "sort", skip_serializing_if = "Option::is_none", default)]
    sort: Option<Box<super::ProcedureSortOptions>>,
    #[builder(custom(type = super::ProcedureSearchQuery, convert = Box::new))]
    #[serde(rename = "query")]
    query: Box<super::ProcedureSearchQuery>,
}
impl ProcedureSearchState {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(query: super::ProcedureSearchQuery) -> Self {
        Self::builder().query(query).build()
    }
    #[inline]
    pub fn sort(&self) -> Option<&super::ProcedureSortOptions> {
        self.sort.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn query(&self) -> &super::ProcedureSearchQuery {
        &*self.query
    }
}
